> -- module Rank2 (Functor2, Mu2, In, it, Nu2, Coit, out) where
> module Rank2 (Functor2(ffmap), Mu2(In), it, Nu2(Coit), out) where

Rank 2 monotonicity.

> class Functor2 ff where 
>     ffmap :: (forall a b. (a -> b) -> f a -> g b) -> 
>              (a -> b) -> ff f a -> ff g b

\paragraph*{Inductive functors.}
Formation and introduction.

> data Mu2 ff a = In (ff (Mu2 ff) a)

Elimination and computation.

> it :: Functor2 ff => (forall b. ff g b -> g b) -> 
>       (a -> b) -> Mu2 ff a -> g b
> it s f (In t) = s (ffmap (it s) f t) 

Functoriality.

> instance Functor2 ff => Functor (Mu2 ff) where
>     fmap = it In

\paragraph*{Coinductive functors.}
Formation and introduction.

> data Nu2 ff b = forall g a. Coit 
>     (forall a. g a -> ff g a) 
>     (a -> b) 
>     (g a)

Elimination and computation.

> out  :: Functor2 ff => Nu2 ff a -> ff (Nu2 ff) a
> out (Coit s f t) = ffmap (Coit s) f (s t)

Functoriality.

> instance Functor2 ff => Functor (Nu2 ff) where
>     fmap = Coit out

